import $ from "jquery";
import mustache from "mustache";
import moment from "moment";
// import journal from "journal";
import "patterns";
// import JQMeter from "./jqmeter";

function notify_init(){
    console.log("notify_init...")
    $("#loading-fallback").show();
    var notify_units_template = $("#notify-units-tmpl").html();
    mustache.parse(notify_units_template);
    var empty_template = $("#notify-empty-tmpl").html();
    mustache.parse(empty_template);

    let g_vue_pagination;
    let g_cur_page = 1;
    let g_page_size = 20;
    let g_assertsp_bak = [];
    if (sessionStorage.getItem("assertp")){
        g_assertsp_bak = $.parseJSON(sessionStorage.getItem("assertp"));
    }
    let units = [];
    for (var i = 0; i<g_assertsp_bak.length; i++){
        units.push(g_assertsp_bak[i]);
    }
    
    let header = {
        Assert: "资产名称",
        IP: "资产IP",
        Opreation: "操作"
    }
    if (!g_vue_pagination){
        g_vue_pagination = new Vue({
            template: '<el-pagination @size-change="handleSizeChange" @current-change="handleCurrentChange" :current-page="current_page" :page-sizes="[20, 40, 60, 80, 100]" :page-size="page_size" layout="total, sizes, prev, pager, next, jumper" :total="total"> </el-pagination>',
            el: "#vue-notify-div",
            methods: {
                handleSizeChange(val) {
                    g_page_size = val;
                    console.log("set g_page_size to:", val);
                    showpage(g_cur_page,val);
                },
                handleCurrentChange(val) {
                    g_cur_page = val;
                    console.log("set g_cur_page to:", val);
                    showpage(val,g_page_size);
                }
            },
            data: {
                current_page: g_cur_page,
                page_size: g_page_size,
                total: units.length,
            }
        })
    } else {
        g_vue_pagination.current_page = g_cur_page;
        g_vue_pagination.page_size = g_page_size;
        g_vue_pagination.total = units.length;
    }
    
    // 只展示这一页的数据
    function showpage(g_cur_page,g_page_size){
        $("#notify-list").html();
        let cur_units = units.slice( (g_cur_page-1) * g_page_size, g_cur_page * g_page_size )
        let text;
        if (cur_units.length > 0){
            text = mustache.render(notify_units_template, {
                table_head: header,
                units: cur_units
            });
        }else{
            text = mustache.render(empty_template);
        }
        $("#notify-list").html(text);
    }
    showpage(g_cur_page,g_page_size);
    $("#loading-fallback").hide();
}

cockpit.translate();
const _ = cockpit.gettext;
moment.locale(cockpit.language);


if (window.location.pathname.indexOf("manager/notify") >  0){
    $(notify_init);
}

